OGRE-Next: Ogre::MeshManager Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
Ogre::MeshManager Class Referencefinal
Core » Resources

Handles the management of mesh resources. More...

`#include <OgreMeshManager2.h>`

Inheritance diagram for Ogre::MeshManager:
[legend]

## Public Member Functions
| MeshManager ()
| ~MeshManager () override
void | _initialise ()
| Initialises the manager, only to be called by OGRE internally.
void | _setVaoManager (VaoManager *vaoManager)
MeshPtr | create (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new mesh.
MeshPtr | createByImportingV1 (const String &name, const String &groupName, v1::Mesh *mesh, bool halfPos, bool halfTexCoords, bool qTangents, bool halfPose=true)
| Imports a v1 mesh to new mesh, with optional optimization conversions.
MeshPtr | createManual (const String &name, const String &groupName, ManualResourceLoader *loader=0)
| Creates a new Mesh specifically for manual definition rather than loading from an object file.
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *params=0, BufferType vertexBufferType=BT_IMMUTABLE, BufferType indexBufferType=BT_IMMUTABLE, bool vertexBufferShadowed=true, bool indexBufferShadowed=true)
| Create a new mesh, or retrieve an existing one with the same name if it already exists.
Real | getBoundsPaddingFactor ()
| Gets the factor by which the bounding box of an entity is padded.
MeshPtr | getByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Get a resource by name.
MeshPtr | load (const String &filename, const String &groupName, BufferType vertexBufferType=BT_IMMUTABLE, BufferType indexBufferType=BT_IMMUTABLE, bool vertexBufferShadowed=true, bool indexBufferShadowed=true)
| Loads a mesh from a file, making it immediately available for use.
void | loadResource (Resource *res) override
| Sets the listener used to control mesh loading through the serializer.
MeshPtr | prepare (const String &filename, const String &groupName, BufferType vertexBufferType=BT_IMMUTABLE, BufferType indexBufferType=BT_IMMUTABLE, bool vertexBufferShadowed=true, bool indexBufferShadowed=true)
| Prepares a mesh for loading from a file.
void | setBoundsPaddingFactor (Real paddingFactor)
| Sets the factor by which the bounding box of an entity is padded.
Public Member Functions inherited from Ogre::ResourceManager
| ResourceManager ()
| ~ResourceManager () override
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
virtual ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle)
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder () const override
| Gets the relative loading order of resources of this type.
virtual size_t | getMemoryBudget () const
| Get the limit on the amount of memory this resource handler may use.
virtual size_t | getMemoryUsage () const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator ()
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType () const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns () const override
| Gets the file patterns which should be used to find scripts for this ResourceManager.
virtual bool | getVerbose ()
| Gets whether this manager and its resources habitually produce log output.
virtual ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse the definition of a set of resources from a script file.
virtual ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
virtual void | remove (const ResourcePtr &r)
| Remove a single resource.
virtual void | remove (const String &name)
| Remove a single resource by name.
virtual void | remove (ResourceHandle handle)
| Remove a single resource by handle.
virtual void | removeAll ()
| Removes all resources.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
virtual bool | resourceExists (const String &name)
| Returns whether the named resource exists in this manager.
virtual bool | resourceExists (ResourceHandle handle)
| Returns whether a resource with the given handle exists in this manager.
virtual void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
virtual void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
virtual void | unload (const String &name)
| Unloads a single resource by name.
virtual void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()
Public Member Functions inherited from Ogre::Singleton< MeshManager >
| Singleton ()
| ~Singleton ()
Public Member Functions inherited from Ogre::ManualResourceLoader
| ManualResourceLoader ()
virtual | ~ManualResourceLoader ()
virtual void | prepareResource (Resource *resource)
| Called when a resource wishes to load.

## Static Public Member Functions
static MeshManager & | getSingleton ()
| Override standard Singleton retrieval.
static MeshManager * | getSingletonPtr ()
| Override standard Singleton retrieval.
Static Public Member Functions inherited from Ogre::Singleton< MeshManager >
static MeshManager & | getSingleton ()
static MeshManager * | getSingletonPtr ()

## Additional Inherited Members
Public Types inherited from Ogre::ResourceManager
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef map< ResourceHandle, ResourcePtr >::type | ResourceHandleMap
typedef unordered_map< String, ResourcePtr >::type | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef unordered_map< String, ResourceMap >::type | ResourceWithGroupMap
Public Attributes inherited from Ogre::ResourceManager
| OGRE_AUTO_MUTEX

## Detailed Description

Handles the management of mesh resources.

Remarks
  This class deals with the runtime management of mesh data; like other resource managers it handles the creation of resources (in this case mesh data), working within a fixed memory budget.

## Constructor & Destructor Documentation

## ◆ MeshManager()

Ogre::MeshManager::MeshManager | ( |  | ) |

Referenced by getSingleton(), and getSingletonPtr().

## ◆ ~MeshManager()

Ogre::MeshManager::~MeshManager | ( |  | ) |
| override

## Member Function Documentation

## ◆ _initialise()

void Ogre::MeshManager::_initialise | ( |  | ) |

Initialises the manager, only to be called by OGRE internally.

## ◆ _setVaoManager()

void Ogre::MeshManager::_setVaoManager | ( | VaoManager * | vaoManager | ) |

## ◆ create()

MeshPtr Ogre::MeshManager::create | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )

Create a new mesh.

See also
  ResourceManager::createResource

References Ogre::ManualResourceLoader::ManualResourceLoader().

## ◆ createByImportingV1()

MeshPtr Ogre::MeshManager::createByImportingV1 | ( | const String & | name,
|  | const String & | groupName,
|  | v1::Mesh * | mesh,
|  | bool | halfPos,
|  | bool | halfTexCoords,
|  | bool | qTangents,
|  | bool | halfPose = true )

Imports a v1 mesh to new mesh, with optional optimization conversions.

Remarks
  The vertex stream will be converted to a single interleaved buffer; i.e. if the original mesh had 3 vertex buffers: [1] = POSITION, POSITION, POSITION, POSITION, ... [2] = NORMALS, NORMALS, NORMALS, NORMALS, ... [3] = UV, UV, UV, UV, ... then the v2 mesh will have only 1 vertex buffer: [1] = POSITION NORMALS UV, POS NORM UV, POS NORM UV, POS NORM UV, ... Resulting mesh is reloadable as long as original mesh exists and is reloadable.

Parameters

  name | The name to give the new mesh
  groupName | The name of the resource group to assign the mesh to
  mesh | The source v1 mesh to convert from. You can unload but should not delete this pointer if you want to be able to reload the converted mesh.
  halfPos | True if you want to convert the position data to VET_HALF4 format. Recommended on desktop to reduce memory and bandwidth requirements. Rarely the extra precision is needed. Unfortuntately on mobile, not all ES2 devices support VET_HALF4.
  halfTexCoords | True if you want to convert the position data to VET_HALF2 or VET_HALF4 format. Same recommendations as halfPos.
  qTangents | True if you want to generate tangent and reflection information (modifying the original v1 mesh) and convert this data to a QTangent, requiring VET_SHORT4_SNORM (8 bytes vs 28 bytes to store normals, tangents and reflection). Needs much less space, trading for more ALU ops in the vertex shader for decoding the QTangent. Highly recommended on both desktop and mobile if you need tangents (i.e. normal mapping).
  halfPose | True if you want the pose buffer to have pixel format PF_FLOAT16_RGBA which uses significantly less memory. Otherwise it is created with pixel format PF_FLOAT32_RGBA. Rarely the extra precision is needed.

## ◆ createManual()

MeshPtr Ogre::MeshManager::createManual | ( | const String & | name,
|  | const String & | groupName,
|  | ManualResourceLoader * | loader = 0 )

Creates a new Mesh specifically for manual definition rather than loading from an object file.

Remarks
  Note that once you've defined your mesh, you must call Mesh::_setBounds and Mesh::_setBoundingRadius in order to define the bounds of your mesh. In previous versions of OGRE you could call Mesh::_updateBounds, but OGRE's support of write-only vertex buffers makes this no longer appropriate.

Parameters

  name | The name to give the new mesh
  groupName | The name of the resource group to assign the mesh to
  loader | ManualResourceLoader which will be called to load this mesh when the time comes. It is recommended that you populate this field in order that the mesh can be rebuilt should the need arise

References Ogre::ManualResourceLoader::ManualResourceLoader().

## ◆ createOrRetrieve()

ResourceCreateOrRetrieveResult Ogre::MeshManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | params = 0,
|  | BufferType | vertexBufferType = BT_IMMUTABLE,
|  | BufferType | indexBufferType = BT_IMMUTABLE,
|  | bool | vertexBufferShadowed = true,
|  | bool | indexBufferShadowed = true )

Create a new mesh, or retrieve an existing one with the same name if it already exists.

Parameters

  vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

See also
  ResourceManager::createOrRetrieve

References Ogre::ManualResourceLoader::ManualResourceLoader(), and Ogre::BT_IMMUTABLE.

## ◆ getBoundsPaddingFactor()

Real Ogre::MeshManager::getBoundsPaddingFactor | ( |  | ) |

Gets the factor by which the bounding box of an entity is padded.

Default is 0.01

## ◆ getByName()

MeshPtr Ogre::MeshManager::getByName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Get a resource by name.

See also
  ResourceManager::getResourceByName

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ getSingleton()

static MeshManager & Ogre::MeshManager::getSingleton | ( |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

References MeshManager().

## ◆ getSingletonPtr()

static MeshManager * Ogre::MeshManager::getSingletonPtr | ( |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

References MeshManager().

## ◆ load()

MeshPtr Ogre::MeshManager::load | ( | const String & | filename,
|  | const String & | groupName,
|  | BufferType | vertexBufferType = BT_IMMUTABLE,
|  | BufferType | indexBufferType = BT_IMMUTABLE,
|  | bool | vertexBufferShadowed = true,
|  | bool | indexBufferShadowed = true )

Loads a mesh from a file, making it immediately available for use.

Note
  If the model has already been created (prepared or loaded), the existing instance will be returned.

Remarks
  Ogre loads model files from it's own proprietary format called .mesh. This is because having a single file format is better for runtime performance, and we also have control over pre-processed data (such as collision boxes, LOD reductions etc).

Parameters

  filename | The name of the .mesh file
  groupName | The name of the resource group to assign the mesh to
  vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

References Ogre::BT_IMMUTABLE.

## ◆ loadResource()

void Ogre::MeshManager::loadResource | ( | Resource * | res | ) |
| overridevirtual

Sets the listener used to control mesh loading through the serializer.

Gets the listener used to control mesh loading through the serializer.

See also
  ManualResourceLoader::loadResource

Implements Ogre::ManualResourceLoader.

## ◆ prepare()

MeshPtr Ogre::MeshManager::prepare | ( | const String & | filename,
|  | const String & | groupName,
|  | BufferType | vertexBufferType = BT_IMMUTABLE,
|  | BufferType | indexBufferType = BT_IMMUTABLE,
|  | bool | vertexBufferShadowed = true,
|  | bool | indexBufferShadowed = true )

Prepares a mesh for loading from a file.

This does the IO in advance of the call to load().

Note
  If the model has already been created (prepared or loaded), the existing instance will be returned.

Remarks
  Ogre loads model files from it's own proprietary format called .mesh. This is because having a single file format is better for runtime performance, and we also have control over pre-processed data (such as collision boxes, LOD reductions etc).

Parameters

  filename | The name of the .mesh file
  groupName | The name of the resource group to assign the mesh to
  vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

References Ogre::BT_IMMUTABLE.

## ◆ setBoundsPaddingFactor()

void Ogre::MeshManager::setBoundsPaddingFactor | ( | Real | paddingFactor | ) |

Sets the factor by which the bounding box of an entity is padded.

The documentation for this class was generated from the following file:

- OgreMeshManager2.h